Package org.flowable.cmmn.api.delegate

# Interface DelegatePlanItemInstance

All Superinterfaces:
  `PlanItemInstance`, `VariableContainer`, `VariableScope`

public interface DelegatePlanItemInstance extends PlanItemInstance, VariableScope

Author:
  Joram Barrez

- ## Method Summary

  Modifier and Type
  Method
  Description
  `FlowableListener`
  `getCurrentFlowableListener()`
  `PlanItemInstanceLifecycleListener`
  `getCurrentLifecycleListener()`
  `PlanItem`
  `getPlanItem()`
  `default PlanItemDefinition`
  `getPlanItemDefinition()`
  `void`
  `setAssignee(String assignee)`
  `void`
  `setCaseDefinitionId(String caseDefinitionId)`
  `void`
  `setCaseInstanceId(String caseInstanceId)`
  `void`
  `setCompletable(boolean completable)`
  `void`
  `setCompletedBy(String completedBy)`
  `void`
  `setCompletedTime(Date completedTime)`
  `void`
  `setCreateTime(Date createTime)`
  `void`
  `setCurrentLifecycleListener(PlanItemInstanceLifecycleListener lifecycleListener, FlowableListener flowableListener)`
  `void`
  `setDerivedCaseDefinitionId(String derivedCaseDefinitionId)`
  `void`
  `setElementId(String elementId)`
  `void`
  `setEndedTime(Date endedTime)`
  `void`
  `setEntryCriterionId(String entryCriterionId)`
  `void`
  `setExitCriterionId(String exitCriterionId)`
  `void`
  `setExitTime(Date exitTime)`
  `void`
  `setExtraValue(String extraValue)`
  `void`
  `setFormKey(String formKey)`
  `void`
  `setLastAvailableTime(Date availableTime)`
  `void`
  `setLastDisabledTime(Date disabledTime)`
  `void`
  `setLastEnabledTime(Date enabledTime)`
  `void`
  `setLastStartedTime(Date startedTime)`
  `void`
  `setLastSuspendedTime(Date suspendedTime)`
  `void`
  `setLastUnavailableTime(Date availableTime)`
  `void`
  `setName(String name)`
  `void`
  `setOccurredTime(Date occurredTime)`
  `void`
  `setPlanItemDefinitionId(String planItemDefinitionId)`
  `void`
  `setPlanItemDefinitionType(String planItemDefinitionType)`
  `void`
  `setReferenceId(String referenceId)`
  `void`
  `setReferenceType(String referenceType)`
  `void`
  `setStage(boolean isStage)`
  `void`
  `setStageInstanceId(String stageInstanceId)`
  `void`
  `setStartTime(Date startTime)`
  Deprecated.
  use `setCreateTime(Date)` instead
  `void`
  `setStartUserId(String startUserId)`
  `void`
  `setState(String state)`
  `void`
  `setTenantId(String tenantId)`
  `void`
  `setTerminatedTime(Date terminatedTime)`
  `ReadOnlyDelegatePlanItemInstance`
  `snapshotReadOnly()`
  Create a snapshot read only delegate plan item instance of this delegate plan item instance.

  ### Methods inherited from interface org.flowable.cmmn.api.runtime.PlanItemInstance

  `getAssignee, getCaseDefinitionId, getCaseInstanceId, getCompletedBy, getCompletedTime, getCreateTime, getDerivedCaseDefinitionId, getElementId, getEndedTime, getEntryCriterionId, getExitCriterionId, getExitTime, getExtraValue, getFormKey, getId, getLastAvailableTime, getLastDisabledTime, getLastEnabledTime, getLastStartedTime, getLastSuspendedTime, getLastUnavailableTime, getName, getOccurredTime, getPlanItemDefinitionId, getPlanItemDefinitionType, getPlanItemInstanceLocalVariables, getReferenceId, getReferenceType, getStageInstanceId, getStartTime, getStartUserId, getState, getTenantId, getTerminatedTime, isCompletable, isStage, setLocalizedName`

  ### Methods inherited from interface org.flowable.common.engine.api.variable.VariableContainer

  `getTenantId`

  ### Methods inherited from interface org.flowable.variable.api.delegate.VariableScope

  `getTransientVariable, getTransientVariableLocal, getTransientVariables, getTransientVariablesLocal, getVariable, getVariable, getVariable, getVariableInstance, getVariableInstance, getVariableInstanceLocal, getVariableInstanceLocal, getVariableInstances, getVariableInstances, getVariableInstances, getVariableInstancesLocal, getVariableInstancesLocal, getVariableInstancesLocal, getVariableLocal, getVariableLocal, getVariableLocal, getVariableNames, getVariableNamesLocal, getVariables, getVariables, getVariables, getVariablesLocal, getVariablesLocal, getVariablesLocal, hasVariable, hasVariableLocal, hasVariables, hasVariablesLocal, removeTransientVariable, removeTransientVariableLocal, removeTransientVariables, removeTransientVariablesLocal, removeVariable, removeVariableLocal, removeVariables, removeVariables, removeVariablesLocal, removeVariablesLocal, setTransientVariable, setTransientVariableLocal, setTransientVariables, setTransientVariablesLocal, setVariable, setVariable, setVariableLocal, setVariableLocal, setVariables, setVariablesLocal`

- ## Method Details

  - ### setName

    void setName(String name)

  - ### setState

    void setState(String state)

  - ### setCaseDefinitionId

    void setCaseDefinitionId(String caseDefinitionId)

  - ### setDerivedCaseDefinitionId

    void setDerivedCaseDefinitionId(String derivedCaseDefinitionId)

  - ### setCaseInstanceId

    void setCaseInstanceId(String caseInstanceId)

  - ### setStageInstanceId

    void setStageInstanceId(String stageInstanceId)

  - ### setStage

    void setStage(boolean isStage)

  - ### setElementId

    void setElementId(String elementId)

  - ### setPlanItemDefinitionId

    void setPlanItemDefinitionId(String planItemDefinitionId)

  - ### setPlanItemDefinitionType

    void setPlanItemDefinitionType(String planItemDefinitionType)

  - ### setStartTime

    @Deprecated void setStartTime(Date startTime)
    Deprecated.
    use `setCreateTime(Date)` instead

  - ### setCreateTime

    void setCreateTime(Date createTime)

  - ### setLastAvailableTime

    void setLastAvailableTime(Date availableTime)

  - ### setLastUnavailableTime

    void setLastUnavailableTime(Date availableTime)

  - ### setLastEnabledTime

    void setLastEnabledTime(Date enabledTime)

  - ### setLastDisabledTime

    void setLastDisabledTime(Date disabledTime)

  - ### setLastStartedTime

    void setLastStartedTime(Date startedTime)

  - ### setLastSuspendedTime

    void setLastSuspendedTime(Date suspendedTime)

  - ### setCompletedTime

    void setCompletedTime(Date completedTime)

  - ### setOccurredTime

    void setOccurredTime(Date occurredTime)

  - ### setTerminatedTime

    void setTerminatedTime(Date terminatedTime)

  - ### setExitTime

    void setExitTime(Date exitTime)

  - ### setEndedTime

    void setEndedTime(Date endedTime)

  - ### setStartUserId

    void setStartUserId(String startUserId)

  - ### setAssignee

    void setAssignee(String assignee)

  - ### setCompletedBy

    void setCompletedBy(String completedBy)

  - ### setReferenceId

    void setReferenceId(String referenceId)

  - ### setReferenceType

    void setReferenceType(String referenceType)

  - ### setCompletable

    void setCompletable(boolean completable)

  - ### setEntryCriterionId

    void setEntryCriterionId(String entryCriterionId)

  - ### setExitCriterionId

    void setExitCriterionId(String exitCriterionId)

  - ### setFormKey

    void setFormKey(String formKey)

  - ### setExtraValue

    void setExtraValue(String extraValue)

  - ### setTenantId

    void setTenantId(String tenantId)

  - ### getCurrentLifecycleListener

    PlanItemInstanceLifecycleListener getCurrentLifecycleListener()

  - ### getCurrentFlowableListener

    FlowableListener getCurrentFlowableListener()

  - ### setCurrentLifecycleListener

    void setCurrentLifecycleListener(PlanItemInstanceLifecycleListener lifecycleListener, FlowableListener flowableListener)

  - ### getPlanItem

    PlanItem getPlanItem()

  - ### getPlanItemDefinition

    default PlanItemDefinition getPlanItemDefinition()

  - ### snapshotReadOnly

    ReadOnlyDelegatePlanItemInstance snapshotReadOnly()
    Create a snapshot read only delegate plan item instance of this delegate plan item instance.
    Returns:
      a `ReadOnlyDelegatePlanItemInstance`